--- octave-build/libgui/src/settings-dialog.cc	2014-05-25 20:07:10.573086465 -0300
+++ octave/libgui/src/settings-dialog.cc	2014-05-26 03:00:24.775116284 -0300
@@ -145,8 +145,8 @@
     settings->value ("editor/create_new_file",false).toBool ());
   ui->terminal_fontName->setCurrentFont (QFont (
     settings->value ("terminal/fontName","Courier New").toString ()) );
-  ui->terminal_fontSize->setValue (
-    settings->value ("terminal/fontSize", 10).toInt ());
+  ui->terminal_fontSize->setValue (
+    settings->value ("terminal/fontSize", 10).toDouble ());
   ui->showFileSize->setChecked (
     settings->value ("filesdockwidget/showFileSize", false).toBool ());
   ui->showFileType->setChecked (
@@ -199,7 +218,7 @@
   ui->proxyUserName->setText (settings->value ("proxyUserName").toString ());
   ui->proxyPassword->setText (settings->value ("proxyPassword").toString ());
 
-  // qorkspace colors
+  // qworkspace colors
   read_workspace_colors (settings);
 
   // terminal colors
@@ -281,11 +300,11 @@
   QGridLayout *style_grid = new QGridLayout ();
   QVector<QLabel*> description (max_style);
   QVector<QFontComboBox*> select_font (max_style);
-  QVector<QSpinBox*> font_size (max_style);
+  QVector<QDoubleSpinBox*> font_size (max_style);
   QVector<QCheckBox*> attrib_font (3 * max_style);
   QVector<color_picker*> color (max_style);
   QVector<color_picker*> bg_color (max_style);
-  int default_size = 10;
+  qreal default_size = 10;
   QFont default_font = QFont ();
   QColor default_color = QColor ();
   QColor dummy_color = QColor (255,0,255);
@@ -302,14 +321,15 @@
       select_font[i]->setObjectName (actual_name+"_font");
       select_font[i]->setMaximumSize (180,QWIDGETSIZE_MAX);
       select_font[i]->setMinimumSize (180,1);
-      font_size[i] = new QSpinBox ();
+      font_size[i] = new QDoubleSpinBox ();
+      font_size[i]->setDecimals(1);
       font_size[i]->setObjectName (actual_name+"_size");
       if (styles[i] == 0) // the default
         {
           select_font[i]->setCurrentFont (actual_font);
           default_font = actual_font;
-          font_size[i]->setRange (6,24);
-          default_size = actual_font.pointSize ();
+          font_size[i]->setRange (6.0, 24.0);
+          default_size = actual_font.pointSizeF ();
           font_size[i]->setValue (default_size);
           default_color = lexer->defaultPaper ();
           bg_color[i] = new color_picker (default_color);
@@ -319,8 +339,8 @@
           select_font[i]->setCurrentFont (actual_font);
           if (actual_font.family () == default_font.family ())
             select_font[i]->setEditText (lexer->description (0));
-          font_size[i]->setRange (-4,4);
-          font_size[i]->setValue (actual_font.pointSize ()-default_size);
+          font_size[i]->setRange (-4.0, 4.0);
+          font_size[i]->setValue (actual_font.pointSizeF () - default_size);
           font_size[i]->setToolTip (tr ("Difference to the default size"));
           if (lexer->paper (styles[i]) == default_color)
             bg_color[i] = new color_picker (dummy_color);
@@ -595,12 +625,12 @@
                                // (enum is not continuous)
   int max_style = get_valid_lexer_styles (lexer, styles);
   QFontComboBox *select_font;
-  QSpinBox *font_size;
+  QDoubleSpinBox *font_size;
   QCheckBox *attrib_font[3];
   color_picker *color;
   color_picker *bg_color;
-  int default_size = 10;
-  QFont default_font = QFont ("Courier New",10,-1,0);
+  qreal default_size = 10;
+  QFont default_font = QFont ("Courier New", 10, -1,0);
   QColor default_color = QColor ();
   QColor dummy_color = QColor (255,0,255);
 
@@ -608,7 +638,7 @@
     {
       QString actual_name = lexer->description (styles[i]);
       select_font    = tab->findChild <QFontComboBox *>(actual_name+"_font");
-      font_size      = tab->findChild <QSpinBox *>(actual_name+"_size");
+      font_size      = tab->findChild <QDoubleSpinBox *>(actual_name+"_size");
       attrib_font[0] = tab->findChild <QCheckBox *>(actual_name+"_bold");
       attrib_font[1] = tab->findChild <QCheckBox *>(actual_name+"_italic");
       attrib_font[2] = tab->findChild <QCheckBox *>(actual_name+"_underline");
@@ -628,10 +658,10 @@
           if (styles[i] == 0)
             {
               default_size = font_size->value ();
-              new_font.setPointSize (font_size->value ());
+              new_font.setPointSizeF (font_size->value ());
             }
           else
-            new_font.setPointSize (font_size->value ()+default_size);
+            new_font.setPointSizeF (font_size->value () + default_size);
         }
       if (attrib_font[0])
         new_font.setBold (attrib_font[0]->isChecked ());